/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */

import LuminicBox.Log.Logger;
import LuminicBox.Log.ConsolePublisher;

class org.flowlib.AbstractColorTransform {
	
	private var clips:Array;
	private var transformed:Object;
	private var normal:Object;
	private var logger:Logger;
	
	public function AbstractColorTransform() {
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
		clips = new Array();
		transformed = new Object();
		normal = new Object();
		initTransforms();
	}
	
	private function initTransforms():Void {
		initTransformed(transformed);
		initNormal(normal);
	}
	
	private function initTransformed(transform:Object):Void {
	}
	
	private function initNormal(transform:Object):Void {
	}
	
	public function addClip(clip:MovieClip):Void {
		clips.push(new Color(clip));
		applyNormal();
	}

	public function applyNormal():Void {
		apply(normal);
	}

	public function applyTransform():Void {
		apply(transformed);
	}
	
	private function apply(transform:Object):Void {
		for (var i:Number = 0; i < clips.length; i++) {
			var clip:MovieClip = clips[i];
			clip.setTransform(transform);
		}		
	}
}
