import org.flowlib.AlphaCycleEffect;

/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */

class org.flowlib.DelayedFade {
	private var clip:Object;
	private var fadeIn:Boolean;
	private var fadeInterval:Number;

	public static function execute(clip:Object, fadeIn:Boolean, delayMillis:Number):Void {
		if (clip.delayedFadeEffect) {
			cancel(clip);
		}
		var fade:DelayedFade = new DelayedFade(clip, fadeIn);
		fade.executeDelayed(delayMillis);
	}
	
	private static function cancel(clip:Object):Void {
		clip.delayedFadeEffect = undefined;
	}

	private function DelayedFade(clip:Object, fadeIn:Boolean) {
		this.clip = clip;
		this.fadeIn = fadeIn;
		clip.delayedFadeEffect = this;
	}
	
	private function executeDelayed(delayMillis:Number):Void {
		this.fadeInterval = setInterval(this, "doFade", delayMillis, clip);
	} 
	
	private function doFade(clip:Object):Void {
		if (! clip.delayedFadeEffect) { 
			clearInterval(fadeInterval);
			return;
		}
		clip.delayedFadeEffect = undefined;
		clearInterval(fadeInterval);
		AlphaCycleEffect.fade(clip, fadeIn);
	}
}
