﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */

class org.flowplayer.ClipDescriptor {
	private var symbolName:String;
	private var name:String;
	private var url:String;
	private var emptyMovie:Boolean;
	
	public static function forEmptyMovie(name:String):ClipDescriptor {
		return new ClipDescriptor(undefined, name, undefined, true);
	}

	public function ClipDescriptor(symbolName:String, name:String, url:String, emptyMovie:Boolean) {
		this.symbolName = symbolName;
		this.name = name;
		this.url = url;
		this.emptyMovie = emptyMovie;
	}

	public function getSymbolName():String {
		return symbolName;
	}
	
	public function getName():String {
		return name;
	}
	
	public function getURL():String {
		return url;
	}
	
	public function toString():String {
		return this.name + ", " + this.url;
	}
	
	public function isEmptyMovie():Boolean {
		return emptyMovie;
	}
}