﻿import org.flowplayer.Util;

/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
class org.flowplayer.PlaybackStatus {

	private var myTotalDuration:Number;
	private var myTime:Number;
	private var myTotalBufferSize:Number;
	private var myBufferLength:Number;
	private var streaming:Boolean;

	public function PlaybackStatus(totalDuration:Number, time:Number, totalBufferSize:Number, bufferLength:Number, isStreaming:Boolean) {
		this.myTotalDuration = totalDuration || 0;
		this.myTime = time || 0;
		this.myTotalBufferSize = totalBufferSize || 0;
		this.myBufferLength = bufferLength || 0;
		this.streaming = isStreaming;
	}
	
	public function get totalDuration():Number {
		return Util.checkForNonNumbers(myTotalDuration);
	}
	
	public function get time():Number {
		return Util.checkForNonNumbers(this.myTime);
	}
	
	public function get totalBufferSize():Number {
		return Util.checkForNonNumbers(this.myTotalBufferSize);
	}
	
	public function get currentBufferLength():Number {
		return Util.checkForNonNumbers(this.myBufferLength);
	}
	
	public function toString() : String {
		return "org.flowplayer.PlaybackStatus, time " + myTime + ", duration " + myTotalDuration + ", buffer length " + myBufferLength + ", buffer size " + myTotalBufferSize;
	}
	
	public function isStreaming():Boolean {
		return streaming;
	}
}