﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */

import org.flowplayer.*;
import LuminicBox.Log.Logger;
import org.flowplayer.playlist.Clip;
import org.flowlib.Observable;
import LuminicBox.Log.ConsolePublisher;

/**
 * A Controller for SWF playback. This controller is able load and play an external SWF from the
 * provided URL. 
 */
class org.flowplayer.SWFController extends AbstractDurationTrackingMediaControl implements MediaControl {

	private var container:MovieClip;
	private var loader:MovieClipLoader;

	public function SWFController() {
		super();
		loader = new MovieClipLoader();
		loader.addListener(this);
	}
	
	public function attachView(videoMc:MovieClip, mediaType:String):Void {
		this.container = videoMc;
	}

	public function onStartBuffering(clip:Clip):Void {
		logger.debug("SWFVideoController.onStartBuffering()");
		dispatchEventWithObj("onLoadBegin", clip);		
		dispatchEvent("onStartBuffering");
		logger.debug("starting loading of SWF into " + container + " using URL " + clip.getURL());
		loader.loadClip(clip.getURL(), container);
	}
	
	public function onLoadInit(target:MovieClip):Void {
		logger.debug("onLoadInit(), target " + target);
		MovieClip(container).gotoAndPlay(0);
		dispatchEvent("onBufferFull");
	}
	
	public function onLoadError(targetMc:MovieClip, errorCode:String) {
		logger.error("Error loading SWF, error code: " + errorCode);
	}

	public function setSound(sound : Sound) : Void {
	}


	public function setViewVisibility():Boolean {
		return false;
	}

	public function allowCenterViewOnLoadBegin() : Boolean {
		return false;
	}
	
	public function rewind():Void {
	}
}