import org.flowlib.NewAbstractMovieClip;
/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
class org.flowplayer.ads.InVideoAd {

	private var id:Number;
	private var url:String;
	private var visibleUrl:String;
	private var imageUrl:String;
	private var title:String;
	private var line1:String;
	private var line2:String;
	private var startTime:Number;
	private var duration:Number;
	
	public function InVideoAd(id:Number, url:String, visibleUrl:String, imageUrl:String, title:String, line1:String, line2:String, startTime:Number, duration:Number) {
		this.id = id;
		this.url = url;
		this.visibleUrl = visibleUrl;
		this.imageUrl = imageUrl;
		this.title = title;
		this.line1 = line1;
		this.line2 = line2;
		this.startTime = startTime;
		this.duration = duration;
	}
	
	public function getId():Number {
		return id;
	}
	
	public function getUrl():String {
		return url;
	}
	
	public function getVisibleUrl():String {
		return visibleUrl;
	}
	
	public function getImageUrl():String {
		return imageUrl;
	}
	
	public function getTitle():String {
		return title;
	}
	
	public function getLine1():String {
		return line1;
	}
	
	public function getLine2():String {
		return line2;
	}
	
	public function getStartTime():Number {
		return startTime;
	}
	
	public function getEndTime():Number {
		// for some reason we need to cast these to ints before addition
		// otherwise we get string catenation as a result ?!?!
		return int(getStartTime()) + int(getDuration());
	}
	
	public function getDuration():Number {
		return duration;
	}
	
	public function toString():String {
		return "[InVideoAd] id = " + id + ", url '" + url + "', imageUrl '" + imageUrl + "', duration: " + duration + ", start: " + startTime;
	}
	
	public function isShowingAtTime(time:Number):Boolean {
		return (time >= startTime) && (time < getEndTime());
	}
	
	public static function fromObjectsWithProps(adsObject:Object):Array {
		if (! adsObject) return null;
		if (! adsObject.ads) return null;
		var adsArr:Array = adsObject.ads; 
		if (adsArr.length == 0) return new Array();
		
		var ads:Array = new Array();
		var prevAd:InVideoAd;
		for (var i:Number = 0; i < adsArr.length; i++) {
			var adObj:Object = adsArr[i];
			var startTime:Number = int(adObj.startTime) || nextAdStartTime(prevAd);
			var ad:InVideoAd = new InVideoAd(adObj.id, adObj.url, adObj.visibleUrl, adObj.image, adObj.title, adObj.line1, adObj.line2, startTime, adObj.duration);
			ads.push(ad);
			prevAd = ad;
		}
		return ads;
	}

	private static function nextAdStartTime(ad:InVideoAd):Number {
		if (! ad) return 3;
		return ad.getEndTime() + 3;
	}

}