/**
 * @author anssi
 */
class org.flowplayer.menu.FlowMenuItem {
	
	private var myName:String;
	private var myMenuObj:Object;
	private var selected:Boolean;
	private var selectable:Boolean;
	
	public static function createSelectableItem(name:String, menuObj:Object, makeSelected:Boolean):FlowMenuItem {
		return new FlowMenuItem(name, menuObj, makeSelected, true);
	}

	/*
	 * Creates a menu item that is not 'selectable'. I.e. it should not ever
	 * be highlighted as selected when rendered in a menu. Normally this menu
	 * item triggers some kind of action.
	 */
	public static function createActionItem(name:String, menuObj:Object) : FlowMenuItem {
		return new FlowMenuItem(name, menuObj, false, false);
	}

	private function FlowMenuItem(name:String, menuObj:Object, makeSelected:Boolean, selectable:Boolean) {
		this.myName = name;
		this.myMenuObj = menuObj;
		this.selected = makeSelected;
		this.selectable = selectable;
	} 
	
	public function get name():String {
		return myName;
	}
	
	public function get object():Object {
		return myMenuObj;
	}

	public function get isSelectable():Boolean {
		return selectable;
	}
	
	public function get isSelected():Boolean {
		return selected;
	}
	
	public function toString():String {
		return "FlowMenuItem, name = '" + myName + "', obj = " + myMenuObj;
	}

}