/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowlib.AbstractSlider;
import org.flowplayer.Util;
import org.flowplayer.config.Config;
import org.flowplayer.skin.Skin;

class org.flowplayer.skin.GraySkin extends Skin {
	
	function GraySkin(config:Config) {
		super(config, 'gray');
	}
			
	private function arrangeSliderDefault(slider:AbstractSlider):Void {
		slider.mcLabel._width = 80;
		var barHeight:Number = slider.barHeight;
		var barXPos:Number = slider.barXPos;
		
		Util.arrangeClip(slider.mcBackground, 0, 0, slider.__width - 1, barHeight);
		Util.arrangeClip(slider.mcBorder, barXPos, 0, slider.__width - barXPos - (slider.mcLabel._visible ? slider.mcLabel._width : 0), barHeight);
	 	
		slider.mcValue._height = barHeight;
		slider.mcValue2._height = barHeight;
		slider.mcDragger._height = barHeight;

		slider.mcValue._x = barXPos;
		slider.mcValue2._x = barXPos;
		slider.mcValue._width = 0;
		slider.mcValue2._width = 0;
		slider.mcDragger._x = barXPos + slider.mcValue._width;
		
		Util.centerClip(slider.mcBorder, null, barHeight);
		Util.centerClip(slider.mcValue, null, barHeight);
		Util.centerClip(slider.mcValue2, null, barHeight);
		Util.centerClip(slider.mcDragger, null, barHeight);
		slider.mcLabel._y = 0;
		if (slider.mcLabel) {
			slider.mcLabel._x = slider.mcBorder._width + 4;
		}
//		slider.mcLabel._y = centeredY(slider.mcLabel, slider.mcDragger);
	}
		
	public function useAlphaChangeForButtonHover():Boolean {
		return false;
	}
			
	public function drawProgressBarBorderTo(mcBorder:MovieClip):Void {
		drawRectangleWithGradientFill2(mcBorder, 100, 14, getProgressBarBorderColor1(), getProgressBarBorderColor2(), true);
	}
	
	public function drawVolumeBarBorderTo(mcBorder:MovieClip):Boolean {
		drawRectangleWithGradientFill2(mcBorder, 100, 14, getProgressBarBorderColor1(), getProgressBarBorderColor2(), true);
		return true;
	}
	
 	public function getProgressIndicatorColor2():Number {
 		if (config.getProgressIndicatorColor2() != undefined)
 			return config.getProgressIndicatorColor2();
		return 0x555555;
 	}
 	
 	public function getBufferIndicatorColor1():Number {
 		if (config.getBufferIndicatorColor1() != undefined)
 			return config.getBufferIndicatorColor1(); 
		return 0xAAAAAA;
 	}
 	
 	public function getBufferIndicatorColor2():Number {
 		if (config.getBufferIndicatorColor2() != undefined)
 			return config.getBufferIndicatorColor2();
		return 0xDDDDDD;
 	}
 	
 	public function getProgressBarBorderColor1():Number {
 		if (config.getProgressBarBorderColor1())
 			return config.getProgressBarBorderColor1();
		return 0xDDDDDD;
 	}
 	
 	public function getProgressBarBorderColor2():Number {
 		if (config.getProgressBarBorderColor2())
 			return config.getProgressBarBorderColor2();
		return 0xEEEEEE;
 	}

	public function getControlBarBackgroundColor():Number {
		if (config.getControlBarBackgroundColor() != undefined)
			return config.getControlBarBackgroundColor();
		return 0xAAAAAA;
	}
	
	public function getTimeDisplayFontColor():Number {
		if (config.getTimeDisplayFontColor() != undefined)
			return config.getTimeDisplayFontColor();
		return 0x000000;
	}

	public function getControlAreaMargins():Array {
		return [1, 1, 0, 1];
	}
	
	public function getProgressBarAreaHeight():Number {
 		return 15;
	}
	
	public function getProgressBarHeight():Number {
 		return 15;
	}
	
	public function getVolumeSliderHeight() : Number {
		return 15;
	}
	
	public function getProgressBarEdgeClipsHeight() : Number {
		return 15;	
	}
	
	
	public function getSpaceAfterWidget(widget:MovieClip):Number {
		var space:Number = 1;
		
		if (widget._name == 'menuButton')
			space = 1;
		else if (widget._name == 'fullScreenButton')
			space = 1;
		else if (widget._name == 'volume')
			space = 1;
		else if (widget._name == 'volumeIcon')
			space = 4;
		else if (widget._name == 'playButton')
			space = 1;
		else if (widget._name == 'stopButton')
			space = 1;
		else if (widget._name == 'pauseButton')
			space = 1;
		else if (widget._name == 'nextButton')
			space = 1;
		else if (widget._name == 'prevButton')
			space = 1;
		else if (widget._name == 'tracker')
			space = 4;	
		logger.debug("widget name " + widget._name + ", space after " + space);
		return space;
	}
}
