﻿import org.flowplayer.Util;
import org.flowplayer.playlist.Clip;
/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
class org.flowplayer.thumbs.Thumbnail {
	
	private var index:Number;
	private var url:String;
	private var time:Number;
	
	public function Thumbnail(url:String, time:Number, clip:Clip) {
		this.url = url;
		this.time = time;
	}
	
	
	public function getUrl():String {
		return this.url;
	}
	
	public function set pos(pos:Number):Void {
		this.index = pos;
	}
	
	public function get pos():Number {
		return index;
	}
	
	public function toString():String {
		return "Thumbnail:: index " + index + ", URL = " + url + ", time " + time;
	}
	
	public function getTime():Number {
		return time;
	}
	
	public function getTimeFormatted():String {
		return Util.formatSeconds(time);
	}
	
	public static function compare(thumb1:Thumbnail, thumb2:Thumbnail):Number {
		if (thumb1.getTime() < thumb2.getTime()) return -1;
		if (thumb1.getTime() > thumb2.getTime()) return 1;
		return 0;
	}

}