﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.thumbs.ThumbnailView;
import org.flowplayer.thumbs.ThumbStrip;

/**
 * @author Anssi
 */
class org.flowplayer.thumbs.ViewPortThumbStrip extends ThumbStrip {
	private var viewPortWidth:Number;
	private var thumbSpacing:Number;
	
	public function setViewPortWidth(width:Number):Void {
		this.viewPortWidth = width;
	}
	
	public function getWiewPortWidth():Number {
		return viewPortWidth;
	}
		
	private function arrangeThumbs():Void {
		if (! viewPortWidth)
			logger.error("viewPortWidth is not defined!");
		thumbSpacing = (viewPortWidth - 2 * getThumbWidth()) / 3;
		
		var ypos:Number = 0;
		for (var i : Number = 0; i < thumbClips.length; i++) {
			var clip:ThumbnailView = thumbClips[i];
			logger.debug("arranging " + clip._name + ", visible = " + clip._visible);

			clip._x = calculateXPos(i, clip._width);

			clip._y = ypos;
			clip.visible = true;
		}
		dispatchEvent("onArranged", this);
	}
	
	private function calculateXPos(thumbIndex:Number, thumbWidth:Number):Number {
		var pos:Number = thumbIndex * thumbWidth;
		pos += (thumbIndex + 1) * thumbSpacing;
			
		pos += Math.floor(thumbIndex/2) * thumbSpacing;
		return pos;
	}
	
	public function getThumbSpacing():Number {
		return thumbSpacing;
	}
	
	public function getThumbWidth():Number {
		return MovieClip(thumbClips[0])._width;
	}

}