import asunit.framework.TestCase;

import interfaces.SimpleInterface;
import interfaces.ImplementationA;
import interfaces.ImplementationB;
import interfaces.BExtendingImplementation;

class interfaces.SimpleInterfaceTest extends TestCase {
	
	private var objectA:SimpleInterface;
	private var objectB:SimpleInterface;
	private var objectC:SimpleInterface;
	
	public function SimpleInterfaceTest(testMethod:String) {
		super(testMethod);
	}
	
	public function setUp():Void {
		objectA = new ImplementationA();
		objectB = new ImplementationB();
		objectC = new BExtendingImplementation();
	}
	
	public function testImplementationADoStuff():Void {
		assertEquals(100, objectA.doStuff(1, "foo"));
	}
	
	public function testImplementationADoMoreStuff():Void {
		assertEquals("param1 was foo", objectA.doMoreStuff("foo", 1));
	}
	
	public function testImplementationBDoStuff():Void {
		assertEquals(200, objectB.doStuff(1, "foo"));
	}
	
	public function testImplementationBDoMoreStuff():Void {
		assertEquals("param2 was 1", objectB.doMoreStuff("foo", 1));
	}
	
	public function testBExtendingImplementationDoStuff():Void {
		assertEquals(objectB.doStuff(1, "foo"), objectC.doStuff(1, "foo"));
	}
	
	public function testBExtendingImplementationDoMoreStuff():Void {
		assertEquals("overriding implementation", objectC.doMoreStuff("foo", 1));
	}

}