/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.config.HierarchicalConfig;
import org.flowplayer.ControlBar;
import org.flowplayer.FlowPlayer;
import org.flowplayer.skin.Skin;

import asunit.framework.TestCase;
import org.flowplayer.skin.GraySkin;
import org.flowplayer.PlaybackStatus;
import org.flowplayer.skin.AirLightSkin;

/**
 * @author Anssi
 */
class org.flowplayer.ControlBarTest extends TestCase {

	private var bar:ControlBar;
	
	public function ControlBarTest(testMethod : String) {
		super(testMethod);
	}
	
	public function setUp():Void {
		FlowPlayer.config = new HierarchicalConfig("{ playList: [ { url: 'clip1' }, { url: 'clip2' } ], showMenu: false, showFullScreenButton: false, showStopButton: true, showVolumeSlider: false, showScrubber: false, showPlayListButtons: false }", "test config");
	}
	
	public function testGraySkin():Void {
		bar = ControlBar(attachMovie("ControlBar"));
		bar.setSkin(new GraySkin(FlowPlayer.config));
		bar.setSize(400, 30, true);
		bar._y = 100;
		bar.tracker.update(new PlaybackStatus(120, 0, 200, 0, false));
	}

}