﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.Util;

import asunit.framework.TestCase;

/**
 * @author anssi
 */
class org.flowplayer.URLUtilTest extends TestCase {

	public function testAddBaseURLDoesNotMungleFilesContainingCompleteURLs() {
		var fileWithCompleteUrl:String = "http://hello/world.flv";
		assertEquals(fileWithCompleteUrl, Util.addBaseURL("/foo", fileWithCompleteUrl));
	}
	
	public function testAddBaseURLDoesNotAddUndefined() {
		assertEquals("foo", Util.addBaseURL(undefined, "foo"));
	}
	
	public function testAddBaseURL() {
		assertEquals("foo/bar", Util.addBaseURL("foo", "bar"));
	}
	
}