/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.ads.InVideoAd;
import org.flowplayer.ads.InVideoAdController;
import org.flowplayer.ads.InVideoAdView;
import org.flowplayer.config.HierarchicalConfig;
import org.flowplayer.playlist.Clip;
import org.flowplayer.skin.Skin;

import asunit.framework.TestCase;

import LuminicBox.Log.ConsolePublisher;
import org.flowplayer.ads.AdServerClient;

class org.flowplayer.ads.InVideoAdControllerTest extends TestCase {
	
	private var adServerUrl:String = "http://adserver.flowplayer.org/ads";
	private var adServerAuth:String = "foo";
	private var controller:InVideoAdController;
	private var client : AdServerClient;
	private var view:InVideoAdView;
	private var time : Number;


	public function setUp():Void {
		var config:HierarchicalConfig = new HierarchicalConfig("{ adServerUrl: '"+adServerUrl+"', adServerAuth: '"+adServerAuth+"' }", "test config");
		client = new AdServerClient(config);
		this.controller = new InVideoAdController(client, undefined);

		view = InVideoAdView(attachMovie("InVideoAdView"));
		view.mySkin = Skin.create(null, null, null, "gray");
		view.setSize(300, 70);
		view._x = 100;
		view._y = 100;
		controller.setView(view);
	}
		
	public function InVideoAdControllerTest(testMethod : String) {
		super(testMethod);
	}
	
	public function testShowAds():Void {
		//adObj.id, adObj.url, adObj.image, adObj.title, adObj.body, startTime, adObj.duration
		var ezpzUrl:String = "http://flowplayer.org/images/ezpz.gif";
		var ensoUrl:String = "http://flowplayer.org/images/smallenso.png";
		var ads:Array = [
			{ id: "flowplayerad", url: "http://flowplayer.org", visibleUrl: 'http://flowplayer.org/adserver', image: ensoUrl, title: "In-Video Advertising", line1: "Advertise here", line2: "Ads by FlowPlayer, clicks are free!", duration: 5 },
			{ id: "dogfood", url: "http://dogfood.com", image: ezpzUrl, title: "Dog food", line1: "Internet dog food store.", line2: "Best stuff for your hounds!", duration: 5 },
			{ id: "books", url: "http://booksyeah.com", image: ensoUrl, title: "Books for sale", line1: "Technical and cooking books.", line2: "Special offers this month.", duration: 10 }
		];
		var clip:Clip = Clip.createSimple("http://flowplayer.org/vide", "honda_accord.flv", "foo");
		clip.setAds(InVideoAd.fromObjectsWithProps(ads));
		controller.onAdsLoaded(clip);
		this.time = 0;
		setInterval(this, "updatePlayBackTime", 500);
	}
	
	private function updatePlayBackTime():Void {
		controller.onPlaybackTimeProgress(time++);
	}
}