/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.as2lib.Config;
import org.flowplayer.config.RTMPConfigLoader;

import asunit.framework.TestCase;

import LuminicBox.Log.ConsolePublisher;
import LuminicBox.Log.Logger;

/**
 * @author Anssi
 */
class org.flowplayer.config.RTMPConfigLoaderTest extends TestCase {

	private var loader:RTMPConfigLoader;
	public static var config:Object;
	private static var logger:Logger;
	
	public function RTMPConfigLoaderTest(testMethod : String) {
		super(testMethod);
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
	}

	public function testLoad():Void {
		loader = new RTMPConfigLoader();
		loader.addListener(RTMPConfigLoader.EVENT_CONFIG_LOADED, this);
		loader.load("rtmp://localhost/floobs_mediaserver", "anssi");
		checkConfigLoaded.config = config;
		var checkLoadedIntervalId:Number = setInterval(checkConfigLoaded, 500);
		logger.debug("created interval " + checkLoadedIntervalId);
	}
	
	public function checkConfigLoaded():Void {
		if (! RTMPConfigLoaderTest.config) {
			RTMPConfigLoaderTest.logger.error("config was not loaded");
		}
	}
	
	public function onRtmpConfigLoaded(config:Object):Void {
		logger.debug("onRtmpConfigLoaded");
		RTMPConfigLoaderTest.config = config;
	}

}