import org.flowplayer.image.ImageControl;
import org.flowplayer.image.LayeredImagesView;
import org.flowplayer.playlist.PlayList;

import asunit.framework.TestCase;
import org.flowplayer.MediaView;

/**
 * @author anssi
 */
class org.flowplayer.image.ImageControlTest extends TestCase {

	private var control:ImageControl;
	private var playList:PlayList;
	
	public function setUp():Void {
		var clips:Array = new Array();

		clips.push({ url : "Thumb1.jpg", duration : 3 });
		clips.push({ url : "Thumb2.jpg", duration : 5 });
		clips.push({ url : "Thumb3.jpg", duration : 7 });
		clips.push({ url : "Thumb2.jpg", duration : 7 });
		
		this.playList = PlayList.fromObjectsWithProps("../resources/sample_videos/honda_ad", clips);
		this.control = new ImageControl();
		
		var display:LayeredImagesView = LayeredImagesView(attachMovie("ImageView"));
		control.attachView(display);
		control.addListener("onClipDone", this);
	}
	
	public function testStartBuffering():Void {
		control.startBuffering();
		assertFalse("was already playing", control.isPlaying());
	}
	
	public function testPlayAfterBuffering():Void {
		control.startBuffering();
		assertFalse("was already playing", control.isPlaying());

		control.play();
		assertTrue("was not playing", control.isPlaying());
	}
	
	public function onClipDone():Void {
		if (playList.hasNext()) {
			control.play(playList.next());
		}
	}	
}