
import asunit.framework.TestCase;

import LuminicBox.Log.ConsolePublisher;
import LuminicBox.Log.Logger;
import org.flowplayer.image.LayeredImagesView;
import org.flowplayer.MediaSize;
import org.flowplayer.button.FlowButton;

/**
 * @author anssi
 */
class org.flowplayer.image.LayeredImagesViewTest extends TestCase {
	
	private var images:LayeredImagesView;
	private var logger:Logger;
	private var loadedCount:Object;
		
	public function LayeredImagesViewTest(name:String) {
		super(name);
	}
	
	public function setUp():Void {
		images = LayeredImagesView(attachMovie("LayeredImagesView"));
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
		images.setMaxSize(480, 320);
		loadedCount = 0;
		images.addLoadListener(this);
	}
	
	public function testInstanceCreated():Void {
		assertTrue("instance was not created", images instanceof LayeredImagesView);
	}
	
	public function testLoadImages():Void {
		var url2:String = "../resources/sample_videos/honda_ad/Thumb1.jpg";
		var url1:String = "../resources/playButtonBig.png";
		images.load(url1, false, url2, true);
		images.resizeTo(MediaSize.FITTED_PRESERVING_ASPECT_RATIO);
	}

	public function testSetOverlay():Void {
		var url1:String = "../resources/sample_videos/honda_ad/Thumb1.jpg";
		images.load(undefined, undefined, url1, true);
		
		var overlay:FlowButton = FlowButton(attachMovie("FlowButton"));
		overlay.setButtonFaceClip("Overlay");
		
		images.setTopClip(overlay);
		images.resizeTo(MediaSize.FITTED_PRESERVING_ASPECT_RATIO);		
	}
	
	public function onLoaded():Void {
		logger.debug("overlayed images loaded");
	}
	
}