﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import asunit.framework.TestCase;
import org.flowplayer.thumbs.Thumbnail;

/**
 * @author anssi
 */
class org.flowplayer.thumbs.ThumbnailTest extends TestCase {
	
	var thumb1:Thumbnail;
	var thumb2:Thumbnail;
	var thumb10:Thumbnail;
	
	public function setUp() {
		thumb1 = new Thumbnail(null, 10);
		thumb2 = new Thumbnail(null, 20);
		thumb10 = new Thumbnail(null, 100);
	}
	
	public function testCompare() {
		
		assertTrue("1st smaller than 2nd", Thumbnail.compare(thumb1, thumb2) == -1);
		assertTrue("2nd smaller than 1st", Thumbnail.compare(thumb2, thumb1) == 1);
		assertTrue(Thumbnail.compare(thumb2, thumb10) == -1);
		assertTrue("equal", Thumbnail.compare(thumb1, thumb1) == 0);
	}
	
	public function testSort() {
		var thumbs:Array = [thumb2, thumb10, thumb1];

		thumbs.sort(Thumbnail.compare);
		
		assertEquals("wrong order in " + thumbs, thumb1, thumbs[0]);
		assertEquals("wrong order in " + thumbs, thumb2, thumbs[1]);
		assertEquals("wrong order in " + thumbs, thumb10, thumbs[2]);
	}
	
	public function testGetTimeFormatted() {
		var result = (new Thumbnail(null, 1)).getTimeFormatted();
		assertEquals("1: " + result, "00:01", result);
		
		result = (new Thumbnail(null, 69)).getTimeFormatted();
		assertEquals("2: " + result, "01:09", result);
		
		result = (new Thumbnail(null, 3800)).getTimeFormatted();
		assertEquals("2: " + result, "01:03:20", result);
	}
}